#!/usr/bin/python
############################################################################
#    Copyright (C) 2006 by Cesar Kallas   	#
#    cesarkallas@soulivre.org   #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################
#	1. Projeto - Uma Aplicacao Centralizada
#	Sistemas Distribuidos	-	Prof Eduardo Zagari	-	http://docentes.puc-campinas.edu.br/ceatec/zagari/
#	Pontificia Universidade Catolica de Campinas	-	 PUC Campinas
#	Aluno: Cesar Kallas	-	RA: 02099224	-	Engenharia de Computacao

import sys
from math import sqrt 

#Recebe uma frase do teclado e a retorna de forma invertida para quem chamou a funcao
def inv_frase():
	print "\n1 - Inversao de Frases"
	string = raw_input("Digite a string: ")
	return string[::-1]

# Calcula o maior divisor inteiro de um numero
# Se o maior divisor for 1 e numero for maior que 1, entao retorne o numero (numero primo)
def calc_mdc():
	print "\n2 - Calculo do Maior Divisor"
	numero = raw_input("Numero: ")
	if numero.isdigit() != True:
		print "Numero invalido"
		return 0
	else:
		numero = int(numero)
		if numero <= 1:
			return numero
		mdc = numero
		
		for i in range(1, numero-1):
			if numero % (i) == 0:
				mdc = i
		
		if mdc == 1:
			if numero > 1:
				return numero
		return mdc
	
# Calcula a raiz quadrada de um numero inteiro, se nao existir um valor real, retorna 0
def calc_rquadrada():
	print "\n3 - Calculo da Raiz Quadrada"
	numero = raw_input("Digite o numero: ")
	if numero.isdigit() != True:
		print "Numero invalido"
		return 0
	else:
		raiz = sqrt(float(numero))
		return raiz

def main():
	while(1):
		print "\n=======================================\nOpcoes\n"
		print "1 - Inversao de Frases"
		print "2 - Calculo do Maior Divisor"
		print "3 - Calculo da Raiz Quadrada"
		print "4 - Sair da Aplicacao"
		opcao = raw_input(": ")
		
		if opcao == "4":
			sys.exit()
		elif opcao == "1":
			print(inv_frase())
		elif opcao == "2":
			print(calc_mdc())
		elif opcao == "3":
			print(calc_rquadrada())
		else:
			print "Opcao invalida"
	
if __name__ == "__main__":
	main()
